/* CHCP Proxy by Vasim V. */

/* #define FLUSH_LOG */

/* #define SIGFUNC_DECL int */
/* uncomment previous line for some *nix-systems , if you got compile-error */

#include "chcproxy.h"

#define BSD_SELECT
typedef unsigned char unsgchar;

#ifndef NT_VERSION
#ifndef UNIX_VERSION
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSERRORS
#include <os2.h>
#endif				/* !UNIX_VERSION */
#else
#include <windows.h>
#endif				/* !NT_VERSION */

#if !defined(GCC_VERSION) && !defined(NT_VERSION) && !defined(UNIX_VERSION)
#include <types.h>
#else
#include <sys/types.h>
#endif				/* !GCC_VERSION && !NT_VERSION &&
				 * !UNIX_VERSION */

#if !defined(NT_VERSION) || defined(GCC_VERSION) || defined (UNIX_VERSION)
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#else
#include <winsock.h>
#endif				/* !NT_VERSION || GCC_VERSION || UNIX_VERSION */

#include <stdio.h>

#ifdef USE_CONIO
#ifdef UNIX_VERSION
#include <curses.h>
#else
#include <conio.h>
#endif				/* UNIX_VERSION */
#endif				/* USE_CONIO */

#include <string.h>
#include <time.h>

#ifndef NT_VERSION
#include <sys/time.h>
#ifndef UNIX_VERSION
#include <sys/select.h>
#endif				/* UNIX_VERSION */
#endif				/* !NT_VERSION */

#include "regexp/regexp.h"
#include <stdarg.h>

#ifndef UNIX_VERSION
#include <process.h>
#else
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/wait.h>
#include <sys/errno.h>
#endif				/* !UNIX_VERSION */

#include <signal.h>

#define BUFFER_SIZE 3072	/* buffer size for each input/output thread */
#define MAX_THREADS 1024	/* max number of threads (processes) */
#define MAX_MIME_HEADER_SIZE 2048	/* size for MIME-header
					 * (MAX_MIME_HEADER_SIZE <
					 * BUFFER_SIZE !!!) */
#define MAX_SIZE_LOG_RECORD 1024/* max size for log record */
#define MAX_INCOMING_QUEUE_SIZE 256	/* max queue size for listen */
#define THREAD_STACK_SIZE 32768	/* stack size for new threads */

#ifdef NEED_LINGER
#define LINGER_TIME 240		/* time for linger option (in seconds) */
#endif

#ifdef CLOSE_WAIT
#define SEND_TIME_WAIT 1	/* Time for sleep after sending all data to
				 * client (in seconds) */
#endif

/* Regular expressions for regcomp */
/* see 'man regexp' for details */
#define CONTENT_TYPE_FLAG "[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]"
#define CHARSET_FLAG "; *[Cc][Hh][Aa][Rr][Ss][Ee][Tt]=[ !#-&(-\x7f]*"
#define TEXT_FLAG "([Tt][Ee][Xx][Tt] */[\x20-\x7f]*)|" \
	"([Aa][Pp][Ll][Ii][Cc][Aa][Tt][Ii][Oo][Nn] */ *" \
	"[Xx]-[Ww][Ww][Ww]-[Ff][Oo][Rr][Mm]-[Uu][Rr][Ll][Ee][Nn][Cc][Oo][Dd][Ee][Dd] *)"
#define SPACE "[ \\\r\\\n\\\t]*"
#define CRLF "[\\\r\\\n]"

/* for HTTP-header */
#define CONTENT_FLAG CRLF CONTENT_TYPE_FLAG ": *" TEXT_FLAG CRLF
#define MIME_FLAG CRLF CONTENT_TYPE_FLAG ": *" TEXT_FLAG CHARSET_FLAG CRLF
#define CHARSET_SUBSTRING CHARSET_FLAG

/* for htmls from Microsoft FrontPage . *WHY* ?!?!?!?!? :~~~( */
#define META_FLAG "<" SPACE "[Mm][Ee][Tt][Aa]" SPACE \
	"[Hh][Tt][Tt][Pp]-[Ee][Qq][Uu][Ii][Vv]" SPACE \
	"=" SPACE "[\"\']" CONTENT_TYPE_FLAG "[\"\']" SPACE \
	"[Cc][Oo][Nn][Tt][Ee][Nn][Tt]" SPACE "=" SPACE \
	"[\"\']" TEXT_FLAG CHARSET_FLAG "[\"\']" SPACE ">"

#if defined(GCC_VERSION) || defined(UNIX_VERSION)
#define ERRNO errno
#define S_EINTR EINTR
#ifdef UNIX_VERSION
#define strcmpi(x,y) strcasecmp(x,y)
#else
#define strcmpi(x,y) stricmp(x,y)
#endif				/* UNIX_VERSION */
#define sock_init()
#define sock_deinit()
#define soclose(x) close(x)
#define psock_errno perror
#endif				/* GCC_VERSION || UNIX_VERSION */

#ifdef NT_VERSION
#define gettid() (int) GetCurrentThreadId()
#define DosSleep(x) Sleep(x)
#define DosKillThread(x) TerminateThread(x,0)
#define HMTX HANDLE
#define NULLHANDLE (HANDLE)0
#define THRID HANDLE
#define _create_mutex(w,x,y,z) x=CreateMutex(z,y,w)
#define _open_mutex(x,y) y=OpenMutex(NULL,FALSE,x)
#define _request_mutex(x) (void)WaitForSingleObject(x,INFINITE)
#define _release_mutex(x) (void)ReleaseMutex(x)
#define _close_mutex(x) (void)CloseHandle(x)

#ifndef GCC_VERSION
#define S_EINTR WSAEINTR
#define soclose(x) closesocket(x)
#define sock_deinit() WSACleanup()
#define ERRNO WSAGetLastError()

void
psock_errno(char *s)
{
  fprintf(stderr, "winsock (%d) : %s\n", WSAGetLastError(), s);
}

void
sock_init()
{
  WSADATA         wsaData;
  int             res;

  res = WSAStartup(MAKEWORD(1, 1), &wsaData);
  if (res != 0)
  {
    psock_errno("WSAStartup failed .");
    exit(1);
  }
}
#endif				/* GCC_VERSION */

#else
#ifndef UNIX_VERSION

#define THRID int
#define _create_mutex(w,x,y,z) (void)DosCreateMutexSem(w,&x,(ULONG)z,y)
#define _open_mutex(x,y) (void)DosOpenMutexSem(x,&y)
#define _request_mutex(x) (void)DosRequestMutexSem(x,SEM_INDEFINITE_WAIT)
#define _release_mutex(x) (void)DosReleaseMutexSem(x)
#define _close_mutex(x) (void)DosCloseMutexSem(x)

int
gettid()
{
  PPIB            ppib;
  PTIB            ptib;

  (void) DosGetInfoBlocks(&ptib, &ppib);
  return (int) (ptib->tib_ptib2->tib2_ultid);
}

#ifndef GCC_VERSION
#define S_EINTR SOCEINTR
#define sock_deinit()
#define ERRNO sock_errno()
#endif

#else

#define THRID int
#define gettid() getpid()
#define DosKillThread(x) kill(x,SIGUSR1)
#define DosSleep(x) sleep(x/1000);
#define HMTX int
#define NULLHANDLE 0
#define _create_mutex(w,x,y,z) x=semget(IPC_PRIVATE, 1, IPC_CREAT | 0700); \
		semctl(x,0,SETVAL,(union semun)0)
#define _open_mutex(x,y)
#define _close_mutex(x)	(void)semctl(x, 0, IPC_RMID, NULL)
void
_request_mutex(int id)
{
  struct sembuf   buf[2];

  buf[0].sem_num = 0;
  buf[0].sem_op = 0;
  buf[0].sem_flg = 0;
  buf[1].sem_num = 0;
  buf[1].sem_op = 1;
  buf[1].sem_flg = 0;
  semop(id, buf, 2);
}

void
_release_mutex(int id)
{
  struct sembuf   buf[1];

  buf[0].sem_num = 0;
  buf[0].sem_op = -1;
  buf[0].sem_flg = 0;
  semop(id, buf, 1);
}
#endif				/* !UNIX_VERSION */
#endif				/* NT_VERSION */

/* Data types */
typedef struct sockets
{
  int             proxy_sock;
  int             in_sock;
  int             table;
  int             statr0, statr1, stats0, stats1;
  THRID           child_pid;
}               sockets;

typedef struct shared_data
{
  int             number_threads;
  int             flag_exit;
  int             translate_from_page;
  int             translate_to_page;
  THRID           server_pid;
  int             flag_all_translate;	/* 1 - translate all , 0 - only text */
  int             flag_hex_translate;	/* 1 - translate hex codes , 0 -
					 * ignore hex */
  int             flag_replace_mime;	/* 0 - Cut (Very bad idea !!!) , 1 -
					 * Replace , 2 - Cut '; charset =
					 * xxx' substring, -1 - No action */
  int             flag_replace_meta;	/* 0 - Cut (Very good idea :) ) , 1 -
					 * Replace , 2 - Cut '; charset =
					 * xxx' substring, -1 - No action */
  int             flag_charset_priority;	/* 0 - don't use any headers
						 * (use default charset) 1 -
						 * use charset from
						 * mime-header only , 2 - use
						 * charset from meta only , 3
						 * - use charset from meta
						 * and mime-header
						 * (mime-header is priority)
						 * 4 - use charset from met
						 * and mime-header (meta is
						 * priority) */
  unsgchar        table_to[5][256];
  unsgchar        table_from[5][256];
}               shared_data;

typedef struct bufhex
{
  unsgchar       *buf;
  int             size;
  int             flhexw;
  int             offset;
  int             hexchar;
}               bufhex;


/* Globals data for all processes */
struct regexp  *etable[5];
struct regexp  *emeta;
struct regexp  *echarset;
struct regexp  *emime;
struct regexp  *econtent;
char           *table_exp[5] = {"[Kk][Oo][Ii][- ]?8[- ]?.?", \
  "(([Cc][Pp])|(([Ww][Ii][Nn])([Dd][Oo][Ww][Ss]?)?)|([Aa][Nn][Ss][Ii]))[- ]?1251", \
  "[Ii][Ss][Oo]-?8859-?5", \
  "YOUR", \
  "(([Cc][Pp])|([Aa][Ll][Tt]))[- ]?866"};

/* Names of charsets for replace in headers */
char           *table_name[5] = {"koi8-r", "windows-1251", "iso-8859-5", "your", "cp866"};

char           *flrep_name[4] = {"Pass w/o changes", "Cut all", "Replace charset", \
  "Cut only \'; charset=xxx\'"};
char           *flpri_name[5] = {"Ignore headers", "Look in MIME-header only", \
  "Look in META only", "Look in MIME-header then META", \
  "Look in META then MIME-header"};
FILE           *logerr;
unsigned long   proxy_address;
unsigned short  proxy_port;
HMTX            semlog = NULLHANDLE;
unsgchar        tbcp[4][224];
int             sock;
int             flag_unattended;

#ifdef UNIX_VERSION
int             global_id;	/* id of shared memory segment */
#else
struct shared_data global_data;
#endif				/* UNIX_VERSION */
struct shared_data *gl;

#ifndef C_SET_VERSION
#define _Optlink
#ifdef GCC_VERSION
#define _Inline __inline__
#else
#define _Inline
#endif				/* GCC_VERSION */
#endif				/* !C_SET_VERSION */

#ifndef SIGFUNC_DECL
#define SIGFUNC_DECL void
#endif

#ifndef MIN_THREAD
void _Optlink   new_request(void *num_socket);
void _Optlink   to_proxy_thread(void *idsocks);
#define NEW_REQUEST new_request
#else
void _Optlink   Request(void *num_socket);
#define NEW_REQUEST Request
#endif				/* !MIN_THREAD */

void            menu(int ansi_flag, struct shared_data * gl);
void _Optlink   server_thread(void *socknum);
void            translate(unsgchar * buf, int size, int flag_translate, int table, struct shared_data * gl);
int             sendflush(int sock, unsgchar * buf, int size, int *stat);
void            translate_hex(bufhex * hbuf, int flag_translate, struct shared_data * gl, int table);
_Inline int     xc2d(unsgchar c);
_Inline unsgchar d2xc(int k);
_Inline void    hex_translate(unsgchar * buf, int flag_translate, int table, struct shared_data * gl);
void            fill_tables_translation(struct shared_data * gl);
void            load_table(int table, char *filename);
void            log(const char *fmt,...);
SIGFUNC_DECL    quit(int x);

#ifdef WATCOM_VERSION
#pragma	intrinsic (xc2d, d2xc, hex_translate)
#endif

#ifdef C_SET_VERSION
#define C_VERSION "IBM C/Set"
#else
#ifdef WATCOM_VERSION
#define C_VERSION "Watcom C"
#else
#ifdef GCC_VERSION
#define C_VERSION "Gcc"
#else
#define C_VERSION "Unknown"
#endif				/* GCC_VERSION */
#endif				/* WATCOM_VERSION */
#endif				/* C_SET_VERSION */

#ifdef NT_VERSION
#define C_VERSION_1 C_VERSION " [Win32]"
#else
#ifdef UNIX_VERSION
#define C_VERSION_1 C_VERSION " [Unix]"
#else
#define C_VERSION_1 C_VERSION " [OS/2]"
#endif
#endif				/* NT_VERSION */

#ifdef USE_CONIO
#ifdef UNIX_VERSION
#define COMPILER_VERSION C_VERSION_1 " with curses.h"
#else
#define COMPILER_VERSION C_VERSION_1 " with conio.h"
#endif				/* UNIX_VERSION */
#else
#define COMPILER_VERSION C_VERSION_1 " without conio.h"
#endif				/* USE_CONIO */

#ifdef NO_LOG_THREAD
#define FLUSH_LOG
#endif

void
reg_error(char *s)
{
  fprintf(stderr, "regexp: %s", s);
  exit(1);
}

#ifdef UNIX_VERSION
int
                _beginthread(void (*func) (void *), void *stack, int ssize, void *param)
{
  int             rc;

  rc = fork();
  if (rc < 0)
    return -1;
  else if (rc > 0)
  {
    return rc;
  } else
  {
    (*func) (param);
    exit(0);
  }
}

void
_endthread()
{
  exit(0);
}

#define REGDUP(x) x		/* we don't need do copy expression after
				 * fork */
#define REGFREE(x)

#else

#define REGDUP(x) regdup(x)
#define REGFREE(x) free(x)

#endif				/* UNIX_VERSION */

void
set_signals()
{
#ifdef SIGHUP
  signal(SIGHUP, quit);
#endif
#ifdef SIGINT
  signal(SIGINT, quit);
#endif
#ifdef SIGTERM
  signal(SIGTERM, quit);
#endif
#ifdef SIGALRM
  signal(SIGALRM, quit);
#endif
#ifdef SIGXCPU
  signal(SIGXCPU, quit);
#endif
#ifdef SIGVTALRM
  signal(SIGVTALRM, quit);
#endif
#ifdef SIGPROF
  signal(SIGPROF, quit);
#endif
#ifdef SIGBREAK
  signal(SIGBREAK, quit);
#endif
#ifdef SIGQUIT
  signal(SIGQUIT, quit);
#endif
#ifdef SIGUSR2
  signal(SIGUSR2, quit);
#endif
  signal(SIGUSR1, quit);
  return;
}

void
unset_signals()
{
#ifdef SIGPIPE
  signal(SIGPIPE, SIG_IGN);
#endif
#ifdef SIGHUP
  signal(SIGHUP, SIG_IGN);
#endif
#ifdef SIGINT
  signal(SIGINT, SIG_IGN);
#endif
#ifdef SIGTERM
  signal(SIGTERM, SIG_IGN);
#endif
#ifdef SIGALRM
  signal(SIGALRM, SIG_IGN);
#endif
#ifdef SIGXCPU
  signal(SIGXCPU, SIG_IGN);
#endif
#ifdef SIGVTALRM
  signal(SIGVTALRM, SIG_IGN);
#endif
#ifdef SIGPROF
  signal(SIGPROF, SIG_IGN);
#endif
#ifdef SIGQUIT
  signal(SIGQUIT, SIG_IGN);
#endif
#ifdef SIGUSR2
  signal(SIGUSR2, SIG_IGN);
#endif
#ifdef SIGBREAK
  signal(SIGBREAK, SIG_IGN);
#endif
  return;
}

#ifdef UNIX_VERSION
SIGFUNC_DECL
exitsig(int sig)
{
  signal(SIGUSR1, SIG_IGN);
  shmdt((void *) gl);
  exit(sig);
}
#endif				/* UNIX_VERSION */

main(int argc, char **argv)
{
  unsigned short  port;
  struct sockaddr_in server;
  char           *proxy_addr;
  struct hostent *host_proxy;
  int             res;
  int             rc;
  int             i;
  int             flag_ansi;
  int             on = 1;
  THRID           thrid;

  sock_init();

  if ((argc < 7) || (argc > 14))
  {
    fprintf(stderr, "Usage: %s port proxy proxy_port from_codepage to_codepage flag_all_translate flag_hex_translate flag_header_priority flag_replace_mime flag_replace_meta logfile_name flag_ansi flag_unattended_mode\n", argv[0]);
    exit(1);
  }
  if ((econtent = regcomp(CONTENT_FLAG)) == NULL)
    reg_error("error at compile CONTENT_FLAG");
  if ((echarset = regcomp(CHARSET_SUBSTRING)) == NULL)
    reg_error("error at compile CHARSET_SUBSTRING");
  if ((emime = regcomp(MIME_FLAG)) == NULL)
    reg_error("error at compile MIME_FLAG");
  if ((emeta = regcomp(META_FLAG)) == NULL)
    reg_error("error at compile META_FLAG");
  for (i = 0; i < 5; i++)
    if ((etable[i] = regcomp(table_exp[i])) == NULL)
      reg_error("error at compile table_exp");

#ifndef UNIX_VERSION
  gl = &global_data;
#else

  global_id = shmget(IPC_PRIVATE, sizeof(struct shared_data), IPC_CREAT | SHM_R | SHM_W);
  if (global_id < 0)
  {
    perror("Error at create shared memory segment");
    exit(2);
  }
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
#endif				/* !UNIX_VERSION */
  gl->flag_exit = 0;
  semlog = 0;

  port = (unsigned short) atoi(argv[1]);
  proxy_port = (unsigned short) atoi(argv[3]);
  proxy_addr = argv[2];
  gl->translate_from_page = table_number(atoi(argv[4]));
  gl->translate_to_page = table_number(atoi(argv[5]));
  gl->flag_all_translate = (atoi(argv[6]) != 0);
  if (argc > 7)
    gl->flag_hex_translate = (atoi(argv[7]) != 0);
  else
    gl->flag_hex_translate = !gl->flag_all_translate;
  if (argc < 9)
    gl->flag_charset_priority = 4;
  else
    gl->flag_charset_priority = atoi(argv[8]);
  if (argc < 10)
    gl->flag_replace_mime = 2;
  else
    gl->flag_replace_mime = atoi(argv[9]);
  if (argc < 11)
    gl->flag_replace_meta = 0;
  else
    gl->flag_replace_meta = atoi(argv[10]);
  if (argc < 12)
    logerr = stderr;
  else
  {
    logerr = fopen(argv[11], "a");
    if (logerr == NULL)
    {
      fprintf(stderr, "Can't open log-file\n");
      quit(-1);
    }
    _create_mutex("\\SEM32\\CHCPROXY_LOG", semlog, FALSE, NULL);
    _open_mutex("\\SEM32\\CHCPROXY_LOG", semlog);
  }
  if (argc < 13)
#if !defined(NT_VERSION) && !defined(UNIX_VERSION)
    flag_ansi = 1;
#else
    flag_ansi = 0;
#endif
  else
    flag_ansi = (atoi(argv[12]) != 0);
  flag_unattended = 0;
  if (argc == 14)
    if (atoi(argv[13]))
    {
      flag_unattended = 1;
      fclose(stdout);
      fclose(stderr);
      fclose(stdin);
    }
  load_table(0, "koi_866.cdp");
  load_table(1, "win_866.cdp");
  load_table(2, "iso_866.cdp");
  load_table(3, "tmp_866.cdp");

  if (!strcmpi(proxy_addr, "localhost"))
    proxy_address = (1 * 256 * 256 * 256) + 127;
  else
  {

    if ((proxy_addr[0] >= '0') && (proxy_addr[0] <= '9'))
      proxy_address = inet_addr(proxy_addr);
    else
    {
      host_proxy = gethostbyname(proxy_addr);
      if (host_proxy == NULL)
      {
	fprintf(stderr, "Proxy address %s is unknown\n", proxy_addr);
	quit(-1);
      } else
	proxy_address = *((unsigned long *) host_proxy->h_addr);
    }
  }

  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0)
  {
    psock_errno("Create main socket");
    quit(-1);
  }
  setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (void *) &on, sizeof(on));
  setsockopt(sock, SOL_SOCKET, SO_KEEPALIVE, (void *) &on, sizeof(on));
  server.sin_family = AF_INET;
  server.sin_port = htons(port);
  server.sin_addr.s_addr = INADDR_ANY;

  res = bind(sock, (struct sockaddr *) & server, sizeof(server));
  if (res < 0)
  {
    psock_errno("Bind main socket");
    quit(-1);
  }
  res = listen(sock, MAX_INCOMING_QUEUE_SIZE);
  if (res != 0)
  {
    psock_errno("Listen main socket");
    quit(-1);
  }
  gl->number_threads = 2;
  fill_tables_translation(gl);
  res = _beginthread(&server_thread, NULL, THREAD_STACK_SIZE, NULL);
  if (res == -1)
  {
    log("Startup : _beginthread (fork) error (at run server thread).");
    quit(-1);
  }
  log("Main thread : Server thread started .");
#ifdef UNIX_VERSION
  if (flag_unattended)
  {
    shmdt((void *) gl);
    exit(0);
  }
  unset_signals();
  signal(SIGUSR1, exitsig);
#else
  set_signals();
#endif				/* UNIX_VERSION */
  menu(flag_ansi, gl);
#ifndef UNIX_VERSION
  (void) quit(0);
#else
  thrid = gl->server_pid;
  shmdt((void *) gl);
  kill(thrid, SIGUSR1);
  exit(0);
#endif				/* !UNIX_VERSION */
}

SIGFUNC_DECL
quit(int x)
{
  int             i;

  unset_signals();
  signal(SIGUSR1, SIG_IGN);
  if (x != -1)
    log("Main thread : Exit (signal %d) .", x);
  else
    log("Main thread : Error at startup .");
#ifdef UNIX_VERSION
  killpg(0, SIGUSR1);
#endif				/* UNIX_VERSION */
  DosSleep(1000);

  free(econtent);
  free(echarset);
  free(emime);
  free(emeta);
  for (i = 0; i < 5; i++)
    free(etable[i]);
  if (logerr != stderr)
  {
    _close_mutex(semlog);
    fclose(logerr);
  }
#ifdef UNIX_VERSION
  shmdt((void *) gl);
  shmctl(global_id, IPC_RMID, NULL);
#endif
  soclose(sock);
  sock_deinit();
  exit(x);
}

void            _Optlink
server_thread(void *socknum)
{
  struct sockaddr_in client;
  int             res;
  int             slen;
  int             rc;
  struct linger   ling;

#ifdef UNIX_VERSION
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  set_signals();
#endif				/* UNIX_VERSION */

#ifdef NT_VERSION
  DuplicateHandle(GetCurrentProcess(), GetCurrentThread(), GetCurrentProcess(),
		  &gl->server_pid, 0, TRUE, DUPLICATE_SAME_ACCESS);
#else
  gl->server_pid = gettid();
#endif

  do
  {
    slen = sizeof(client);
    res = accept(sock, (struct sockaddr *) & client, &slen);
    if (res >= 0)
    {
      log("Server thread : New request from address %s .",
	  inet_ntoa(client.sin_addr));
      if ((gl->number_threads + 1) > MAX_THREADS)
      {
	log("Server thread : Too many thread . New request rejected .");
	soclose(res);
      } else
      {
#ifdef NEED_LINGER
	ling.l_onoff = 1;
	ling.l_linger = LINGER_TIME;
#else
	ling.l_onoff = 0;
	ling.l_linger = 0;
#endif
	setsockopt(res, SOL_SOCKET, SO_LINGER, (char *) &ling, sizeof(ling));

	rc = _beginthread(&NEW_REQUEST, NULL, THREAD_STACK_SIZE, (void *) res);
	if (rc == -1)
	{
	  log("Server thread : _beginthread (fork) error (at run new_request thread) .");
#ifndef UNIX_VERSION
	  soclose(res);
#endif
	}
#ifdef UNIX_VERSION
	soclose(res);
	shmdt((void *) gl);
	if (fork() > 0)
	  exit(0);
	gl = (struct shared_data *) shmat(global_id, NULL, 0);
	gl->server_pid = getpid();
#endif				/* UNIX_VERSION */
      }
    }
  } while (!gl->flag_exit);
#ifdef UNIX_VERSION
  (void) quit(0);
#endif
  _endthread();
}

int
table_number(int t)
{
  switch (t)
  {
    case 0:
    return 0;
  case 1:
    return 3;
  case 866:
    return 4;
  case 1251:
    return 1;
  case 8859:
    return 2;
  default:
    return 4;
  }
}

void
menu(int flag_ansi, struct shared_data * gl)
{
  char            ch;
  char           *str1, *str2;
  int             i;
  char           *a[6] = {"\x1b[0;37;40m", "\x1b[H\x1b[2J\x1b[1;32;40m", "\x1b[1;37;40m", \
  "\x1b[1;36;40m", "\x1b[1;33;40m", "\x1b[1;37;42m"};

  if (flag_ansi == 0)
    for (i = 0; i < 6; i++)
      a[i] = "";

  do
  {
    if (flag_unattended || feof(stdin) || ferror(stdin))
    {
  bigloop:
      DosSleep(10000);
      goto bigloop;
    }
    printf("%sCHCP Proxy version %s (%s) by Vasim V.%s\n",
	   a[1], VERSION_STRING, COMPILER_VERSION, a[0]);
    if (gl->flag_all_translate)
      str1 = "(All bytes)";
    else
      str1 = "(Text only)";
    if (gl->flag_hex_translate)
      str2 = "(Hex chars)";
    else
      str2 = "(No hex)";
    printf("Current translation : %s%s%s <-> %s%s %s %s%s\n",
	   a[2], table_name[gl->translate_from_page], a[0],
	   a[2], table_name[gl->translate_to_page], str1, str2, a[0]);
    printf("\tSearch substring \'; charset=xxx\' option : %s%s%s\n",
	   a[2], flpri_name[gl->flag_charset_priority], a[0]);
    printf("\tCut from MIME-header option : %s%s%s\n\tCut from META (with Content-Type) : %s%s%s\n",
	   a[2], flrep_name[1 + gl->flag_replace_mime], a[0],
	   a[2], flrep_name[1 + gl->flag_replace_meta], a[0]);
    printf("%s\t\tKeys :%s\n%sTranslate from (server's codepage) :%s\n",
	   a[3], a[0], a[4], a[0]);
    printf("\t%s1%s From KOI-8\n\t%s2%s From CP 1251\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s3%s From ISO-8859-5\n\t%s4%s From your codepage\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s5%s From CP 866\n%sTranslate to (client's codepage) :%s\n",
	   a[5], a[0], a[4], a[0]);
    printf("\t%s6%s To KOI-8\n\t%s7%s To CP 1251\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s8%s To ISO-8859-5\n\t%s9%s To your codepage\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s0%s To 866\n",
	   a[5], a[0]);
    printf("%sA%s Translate all\n%sH%s Translate hex chars in requests\n",
	   a[5], a[0], a[5], a[0]);
    printf("%sP%s Change search order for substring \'; charset=xxx\'\n",
	   a[5], a[0]);
    printf("%sT%s Change \'Cut from MIME-header\' option\n",
	   a[5], a[0]);
    printf("%sY%s Change \'Cut from META\' option\n",
	   a[5], a[0]);
    printf("%sE%s Exit program\n",
	   a[5], a[0]);
#ifndef USE_CONIO
    printf("\t\tYour choice : ");
    ch = getchar();
#else
    ch = getch();
#endif
    if (flag_ansi == 0)
      printf("\n");
    switch (ch)
    {
    case '1':
      {
	gl->translate_from_page = 0;
	break;
      }
    case '2':
      {
	gl->translate_from_page = 1;
	break;
      }
    case '3':
      {
	gl->translate_from_page = 2;
	break;
      }
    case '4':
      {
	gl->translate_from_page = 3;
	break;
      }
    case '5':
      {
	gl->translate_from_page = 4;
	break;
      }
    case '6':
      {
	gl->translate_to_page = 0;
	fill_tables_translation(gl);
	break;
      }
    case '7':
      {
	gl->translate_to_page = 1;
	fill_tables_translation(gl);
	break;
      }
    case '8':
      {
	gl->translate_to_page = 2;
	fill_tables_translation(gl);
	break;
      }
    case '9':
      {
	gl->translate_to_page = 3;
	fill_tables_translation(gl);
	break;
      }
    case '0':
      {
	gl->translate_to_page = 4;
	fill_tables_translation(gl);
	break;
      }
    case 'A':
    case 'a':
      {
	gl->flag_all_translate = !gl->flag_all_translate;
	break;
      }
    case 'H':
    case 'h':
      {
	gl->flag_hex_translate = !gl->flag_hex_translate;
	break;
      }
    case 'P':
    case 'p':
      {
	gl->flag_charset_priority = (gl->flag_charset_priority + 1) % 5;
	break;
      }
    case 'T':
    case 't':
      {
	gl->flag_replace_mime++;
	if (gl->flag_replace_mime == 3)
	  gl->flag_replace_mime = -1;
	if (!gl->flag_replace_mime)
	  gl->flag_replace_mime = 1;
	break;
      }
    case 'Y':
    case 'y':
      {
	gl->flag_replace_meta++;
	if (gl->flag_replace_meta == 3)
	  gl->flag_replace_meta = -1;
	break;
      }
    case 'E':
    case 'e':
      {
	gl->flag_exit = 1;
	break;
      }
    default:
      break;
    }
  } while (!gl->flag_exit);
}

int
bufcut(unsgchar * buf, int sizebuf, int offset, int size)
{
  if (size == 0)
    return sizebuf;
  memmove(buf + offset, buf + offset + size, sizebuf - offset - size);
  buf[sizebuf - size] = '\0';
  return (sizebuf - size);
}

int
bufreplace(unsgchar * buf, int sizebuf, int offset, int size, unsgchar * replace)
{
  int             len;

  len = strlen(replace);
  if (len > size)
  {
    memmove(buf + offset + len, buf + offset + size, sizebuf - offset - size);
    memcpy(buf + offset, (void *) replace, len);
    buf[sizebuf + len - size] = '\0';
    return (sizebuf + len - size);
  } else
  {
    memcpy(buf + offset, (void *) replace, len);
    return bufcut(buf, sizebuf, offset + len, size - len);
  }
}

int
look_header(unsgchar * buf, int *psize, struct regexp * exp, int flag_replace, struct shared_data * gl)
{
  int             charset, i, len, flag;
  unsgchar       *pstart;
  unsgchar       *pbegin;
  struct regexp  *e;
  unsgchar       *startp, *endp;
  unsgchar        tempchar;

  tempchar = buf[MAX_MIME_HEADER_SIZE];
  buf[MAX_MIME_HEADER_SIZE] = (unsgchar) 0;
  e = REGDUP(exp);
  flag = regexec(e, buf);
  buf[MAX_MIME_HEADER_SIZE] = tempchar;
  startp = (unsgchar *) e->startp[0];
  endp = (unsgchar *) e->endp[0];
  REGFREE(e);
  if (!flag)
    return -1;
  else
  {
    pbegin = startp;
    len = endp - startp;
    pstart = (unsgchar *) malloc(len + 1);
    memcpy(pstart, pbegin, len);
    pstart[len] = '\0';
    charset = -1;
    for (i = 0; i < 5; i++)
    {
      e = REGDUP(etable[i]);
      flag = regexec(e, pstart);
      startp = (unsgchar *) e->startp[0];
      endp = (unsgchar *) e->endp[0];
      REGFREE(e);
      if (flag)
      {
	charset = i;
	break;
      }
    }
    if (flag_replace == 0)
      *psize = bufcut(buf, *psize,
		      pbegin - buf, len);
    else if ((flag_replace == 1) && (charset > -1))
      *psize = bufreplace(buf, *psize,
			  startp - pstart + pbegin - buf,
			  endp - startp,
			  table_name[gl->translate_to_page]);
    else if ((flag_replace == 2) && (charset > -1))
    {
      e = REGDUP(echarset);
      flag = regexec(e, pstart);
      if (flag)
	*psize = bufcut(buf, *psize,
			(unsgchar *) e->startp[0] - pstart + pbegin - buf,
			e->endp[0] - e->startp[0]);
      else
	log("Substring \'; charset=xxx\' not found ! Gluk ...");
      REGFREE(e);
    }
    free(pstart);
  }
  return charset;
}

int
find_header(bufhex * hbuf, int *table, struct shared_data * gl)
{
  unsgchar        tempchar;
  struct regexp  *exp;
  int             fltrans;
  unsgchar       *tempp;
  int             temps;
  int             charset, charset1;

  hbuf->buf[hbuf->size] = (unsgchar) 0;
  tempchar = hbuf->buf[MAX_MIME_HEADER_SIZE];
  hbuf->buf[MAX_MIME_HEADER_SIZE] = (unsgchar) 0;
  exp = REGDUP(econtent);
  fltrans = regexec(exp, hbuf->buf);
  tempp = exp->startp[0];
  REGFREE(exp);
  hbuf->buf[MAX_MIME_HEADER_SIZE] = tempchar;
  if (fltrans)
  {
    log("Thread %d : Text file detected .", gettid());
    temps = hbuf->size - (tempp - hbuf->buf);
    charset = look_header(tempp, &temps, emime, gl->flag_replace_mime, gl);
    charset1 = look_header(tempp, &temps, emeta, gl->flag_replace_meta, gl);
    hbuf->size = temps + (tempp - hbuf->buf);
    switch (gl->flag_charset_priority)
    {
    case 0:
      break;
    case 1:
      {
	if (charset > -1)
	  *table = charset;
	break;
      }
    case 2:
      {
	if (charset1 > -1)
	  *table = charset1;
	break;
      }
    case 3:
      {
	if (charset > -1)
	  *table = charset;
	else if (charset1 > -1)
	  *table = charset1;
	break;
      }
    case 4:
      {
	if (charset1 > -1)
	  *table = charset1;
	else if (charset > -1)
	  *table = charset;
	break;
      }
    default:
      break;
    }
    log("Thread %d : Translate from codepage \'%s\' .",
	gettid(), table_name[*table]);
    if (gl->flag_hex_translate)
      translate_hex(hbuf, 1, gl, *table);
    translate(hbuf->buf, hbuf->size, 1, *table, gl);
  }
  return fltrans;
}

#ifndef MIN_THREAD
#ifdef UNIX_VERSION
struct sockets *socks;
int             socks_id;

SIGFUNC_DECL
deattach_parent(int x)
{
  signal(SIGUSR1, SIG_IGN);
  if (socks->child_pid != 0)
    DosKillThread(socks->child_pid);
  gl->number_threads--;
  shmdt((void *) socks);
  shmdt((void *) gl);
  shmctl(socks_id, IPC_RMID, 0);
  exit(0);
}

SIGFUNC_DECL
deattach_child(int x)
{
  signal(SIGUSR1, SIG_IGN);
  soclose(socks->in_sock);
  soclose(socks->proxy_sock);
  gl->number_threads--;
  socks->child_pid = 0;
  shmdt((void *) socks);
  shmdt((void *) gl);
  exit(0);
}
#endif				/* UNIX_VERSION */

void            _Optlink
new_request(void *num_socket)
{
  unsgchar        buf[BUFFER_SIZE];
  int             res, bytes_in;
  struct sockaddr_in proxy;
  int             flag_end_thread, flag_translate;
  struct sockets  tempsocks;
  bufhex          hbuf;

#ifdef UNIX_VERSION
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  socks_id = shmget(IPC_PRIVATE, sizeof(struct sockets), IPC_CREAT | SHM_R | SHM_W);
  if (socks_id < 0)
  {
    log("Thread %d : Error at create shared memory segment .", gettid());
    socks = &tempsocks;
    socks->child_pid = 0;
    socks->in_sock = (int) num_socket;
    gl->number_threads++;
    goto exit;
  }
  socks = (struct sockets *) shmat(socks_id, NULL, 0);
  unset_signals();
  signal(SIGUSR1, deattach_parent);
  soclose(sock);
#else
  struct sockets *socks;

  socks = &tempsocks;
#endif				/* UNIX_VERSION */
  socks->statr0 = 0;
  socks->stats0 = 0;
  socks->statr1 = 0;
  socks->stats1 = 0;
  gl->number_threads++;
  flag_end_thread = 0;
  socks->table = gl->translate_from_page;
  socks->in_sock = (int) num_socket;
  log("Thread %d : New connection .", gettid());
  socks->proxy_sock = socket(AF_INET, SOCK_STREAM, 0);
  if (socks->proxy_sock < 0)
  {
    log("Thread %d : Error (%d) at create socket .", gettid(), ERRNO);
    goto exit;
  }
  proxy.sin_family = AF_INET;
  proxy.sin_port = htons(proxy_port);
  proxy.sin_addr.s_addr = proxy_address;
  if (connect(socks->proxy_sock, (struct sockaddr *) & proxy, sizeof(proxy)) < 0)
  {
    log("Thread %d : Error (%d) at connect to proxy .", gettid(), ERRNO);
    goto exit;
  }
  res = _beginthread(&to_proxy_thread, NULL, THREAD_STACK_SIZE, socks);
  if (res == -1)
  {
    log("Thread %d : _beginthread (fork) error (at run to_proxy_thread) .",
	gettid());
    soclose(socks->proxy_sock);
    goto exit;
  }
  /*
   * get first MAX_MIME_HEADER_SIZE bytes for detect text/html & text/plain
   * files
   */
  hbuf.flhexw = 0;
  hbuf.offset = 0;
  if (!gl->flag_all_translate)
  {
    bytes_in = 0;
    flag_translate = 0;
    do
    {
      res = recv(socks->proxy_sock, buf + bytes_in, BUFFER_SIZE - bytes_in - 1, 0);
      if (res < 0)
      {
	log("Thread %d : Problem (%d) at receive from proxy .", gettid(), ERRNO);
	res = 0;
      }
      socks->statr1 = socks->statr1 + res;
      bytes_in = bytes_in + res;
    } while ((bytes_in < MAX_MIME_HEADER_SIZE) && ((res != 0) || (ERRNO == S_EINTR)));
    hbuf.buf = buf;
    hbuf.size = bytes_in;
    flag_translate = find_header(&hbuf, &socks->table, gl);
    sendflush(socks->in_sock, hbuf.buf, hbuf.size, &socks->stats0);
  } else
    flag_translate = 1;

  /* receive end of file */

  while ((!gl->flag_exit) && (!flag_end_thread))
  {
    res = recv(socks->proxy_sock, buf + hbuf.offset, BUFFER_SIZE - hbuf.offset, 0);
    if (res == 0)
    {
      log("Thread %d : Proxy close connection .", gettid());
      flag_end_thread = 1;
    } else if (res < 0)
    {
      if (ERRNO != S_EINTR)
      {
	log("Thread %d : Problem (%d) at receive from proxy .", gettid(), ERRNO);
	flag_end_thread = 1;
      } else
	log("Thread %d : EINTR detected at receive from proxy .", gettid());
    } else
    {
      socks->statr1 = socks->statr1 + res;
      hbuf.size = res;
      hbuf.buf = buf + hbuf.offset;
      if (gl->flag_hex_translate && flag_translate)
      {
	translate_hex(&hbuf, 1, gl, socks->table);
      }
      if (hbuf.size > 0)
      {
	translate(hbuf.buf, hbuf.size, flag_translate, socks->table, gl);
	res = sendflush(socks->in_sock, hbuf.buf, hbuf.size, &socks->stats0);
	if (res != hbuf.size)
	{
	  log("Thread %d : Problem (%d) at send to client .", gettid(), ERRNO);
	  flag_end_thread = 1;
	}
      }
    }
  }
#ifndef UNIX_VERSION
  if (socks->child_pid != 0)
    DosKillThread(socks->child_pid);
  gl->number_threads--;
#endif				/* !UNIX_VERSION */
  shutdown(socks->proxy_sock, 2);
  soclose(socks->proxy_sock);
exit:
  log("Thread %d : Connection closed (client: %d->%d proxy: %d->%d) .", gettid(),
      socks->statr0, socks->stats1, socks->statr1, socks->stats0);
#ifdef CLOSE_WAIT
  DosSleep(1000 * SEND_TIME_WAIT);
#endif
  shutdown(socks->in_sock, 2);
  soclose(socks->in_sock);
#ifdef UNIX_VERSION
  (void) deattach_parent(0);
#else
  gl->number_threads--;
#endif				/* UNIX_VERSION */
  _endthread();
}

void            _Optlink
to_proxy_thread(void *idsocks)
{
  unsgchar        buf[BUFFER_SIZE];
  int             res;
  int             flag_receive_exit;
  int             buf_size;
  bufhex          hbuf;
#ifdef UNIX_VERSION

  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  socks = (struct sockets *) shmat(socks_id, NULL, 0);
  signal(SIGUSR1, deattach_child);
#else
  struct sockets *socks;

  socks = (struct sockets *) idsocks;
#endif				/* UNIX_VERSION */

#ifdef NT_VERSION
  DuplicateHandle(GetCurrentProcess(), GetCurrentThread(), GetCurrentProcess(),
		  &socks->child_pid, 0, TRUE, DUPLICATE_SAME_ACCESS);
#else
  socks->child_pid = gettid();
#endif				/* NT_VERSION */

  gl->number_threads++;
  flag_receive_exit = 0;
  hbuf.flhexw = 0;
  hbuf.offset = 0;

  do
  {
    res = recv(socks->in_sock, buf + hbuf.offset, BUFFER_SIZE - hbuf.offset, 0);
    if (res == 0)
    {
      log("Thread %d : Client close connection .", gettid());
      goto exit;
    } else if (res < 0)
    {
      if (ERRNO != S_EINTR)
	goto exit;
      else
	log("Thread %d : EINTR detected at receive from client .", gettid());
    } else
    {
      socks->statr0 = socks->statr0 + res;
      buf_size = res;
      if (gl->flag_hex_translate)
      {
	hbuf.buf = buf + hbuf.offset;
	hbuf.size = res;
	translate_hex(&hbuf, 2, gl, socks->table);
      }
      if (hbuf.size > 0)
      {
	translate(hbuf.buf, hbuf.size, 2, socks->table, gl);
	res = sendflush(socks->proxy_sock, hbuf.buf, hbuf.size, &socks->stats1);
	if (res != hbuf.size)
	{
	  log("Thread %d : Problem (%d) at send to proxy .", gettid(), ERRNO);
	  goto exit;
	}
      }
    }
  } while ((!gl->flag_exit) && (!flag_receive_exit));
exit:
#ifdef UNIX_VERSION
  (void) deattach_child(0);
#else
  socks->child_pid = 0;
#endif				/* UNIX_VERSION */
  _endthread();
}
#endif				/* !MIN_THREAD */

void
translate(unsgchar * buf, int size, int flag_translate, int table, struct shared_data * gl)
{
  int             i;

  switch (flag_translate)
  {
  case 0:
    return;
  case 1:
    {
      for (i = 0; i < size; i++)
	buf[i] = gl->table_from[table][buf[i]];
      return;
    }
  case 2:
    {
      for (i = 0; i < size; i++)
	buf[i] = gl->table_to[table][buf[i]];
      return;
    }
  }
  return;
}

int
sendflush(int sock, unsgchar * buf, int size, int *stat)
{
  int             res, count;

  count = 0;
  do
  {
    res = send(sock, buf, size, 0);
    if (res < 0)
    {
      if (ERRNO != S_EINTR)
	return -1;
      else
	res = 0;
    }
    count = count + res;
    *stat = *stat + res;
  } while (count < size);
  return size;
}

_Inline int
xc2d(unsgchar c)
{
  int             temp;

  temp = toupper(c) - '0';
  if (temp > 9)
    return (temp - 'A' + '9' + 1);
  else
    return temp;
}

_Inline         unsgchar
d2xc(int k)
{
  if (k > 9)
    return (k + 'A' - 10);
  else
    return (k + '0');
}

_Inline void
hex_translate(unsgchar * buf, int flag_translate, int table, struct shared_data * gl)
{
  unsgchar        temp;

  if ((!isxdigit(buf[0])) || (!isxdigit(buf[1])))
    return;
  switch (flag_translate)
  {
  case 0:
    return;
  case 1:
    {
      temp = gl->table_from[table][xc2d(buf[0]) * 16 + xc2d(buf[1])];
      break;
    }
  case 2:
    {
      temp = gl->table_to[table][xc2d(buf[0]) * 16 + xc2d(buf[1])];
      break;
    }
  }
  buf[0] = d2xc(temp / 16);
  buf[1] = d2xc(temp % 16);
  return;
}

unsgchar
char_num(int ch, unsgchar * table)
{
  int             i;

  for (i = 0; ((i < 224) && (*(table + i) != (unsgchar) ch)); i++);
  if (i == 224)
    i = ch - 32;
  return (unsgchar) (i + 32);

}

void
fill_tables_translation(struct shared_data * gl)
{
  int             i, j, flag;

  for (i = 0; i < 32; i++)
  {
    gl->table_to[0][i] = (unsgchar) i;
    gl->table_from[0][i] = (unsgchar) i;
    gl->table_to[1][i] = (unsgchar) i;
    gl->table_from[1][i] = (unsgchar) i;
    gl->table_to[2][i] = (unsgchar) i;
    gl->table_from[2][i] = (unsgchar) i;
    gl->table_to[3][i] = (unsgchar) i;
    gl->table_from[3][i] = (unsgchar) i;
    gl->table_to[4][i] = (unsgchar) i;
    gl->table_from[4][i] = (unsgchar) i;
  }
  for (i = 0; i < 5; i++)
  {
    memset(gl->table_from[i] + 32, 32, 224);
    memset(gl->table_to[i] + 32, 32, 224);
    for (j = 32; j < 256; j++)
    {
      if (i == gl->translate_to_page)
      {
	gl->table_from[i][j] = j;
	gl->table_to[i][j] = j;
      } else
      {
	if (i == 4)
	{
	  gl->table_from[i][j] = char_num(j, tbcp[gl->translate_to_page]);
	  gl->table_to[i][j] = tbcp[gl->translate_to_page][j - 32];
	} else
	{
	  if (gl->translate_to_page == 4)
	  {
	    gl->table_from[i][j] = tbcp[i][j - 32];
	    gl->table_to[i][j] = char_num(j, tbcp[i]);
	  } else
	  {
	    gl->table_from[i][j] = char_num(tbcp[i][j - 32],
					    tbcp[gl->translate_to_page]);
	    gl->table_to[i][j] = char_num(tbcp[gl->translate_to_page][j - 32],
					  tbcp[i]);
	  }
	}
      }
    }
  }
  return;
}

void
load_table(int table, char *filename)
{
  FILE           *f;
#ifdef USE_DEFAULT_DATA_DIR
  char            bufname[256];

  sprintf(bufname, "%s/%s", DEFAULT_DATA_DIR, filename);
  f = fopen(bufname, "rb");
  if (f == NULL)
  {
#endif				/* USE_DEFAULT_DATA_DIR */
    f = fopen(filename, "rb");
    if (f == NULL)
    {
      fprintf(stderr, "Codepage file %s not loaded\n", filename);
      quit(4);
    }
#ifdef USE_DEFAULT_DATA_DIR
  }
#endif
  fread(tbcp[table], 224, 1, f);
  fclose(f);
  return;
}

#ifdef UNIX_VERSION
SIGFUNC_DECL
deattach(int x)
{
  signal(SIGUSR1, SIG_IGN);
  gl->number_threads--;
  shmdt((void *) gl);
  exit(x);
}
#endif				/* UNIX_VERSION */

void            _Optlink
logrecord(void *s)
{
  time_t          ltime;
  struct tm      *ntime;
#ifdef UNIX_VERSION
#ifndef NO_LOG_THREAD
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  signal(SIGUSR1, deattach);
#endif
#endif				/* UNIX_VERSION */
  if (logerr != stderr)
    _request_mutex(semlog);
#ifndef NO_LOG_THREAD
  gl->number_threads++;
#endif
  time(&ltime);
  ntime = localtime(&ltime);
  fprintf(logerr, "%s\t%s\n", asctime(ntime), s);
#ifdef FLUSH_LOG
  fflush(logerr);
#endif
  if (logerr != stderr)
    _release_mutex(semlog);
#ifdef UNIX_VERSION
#ifndef NO_LOG_THREAD
  (void) deattach(0);
#endif
#else
  free(s);
#ifndef NO_LOG_THREAD
  gl->number_threads--;
#endif
#endif				/* UNIX_VERSION */
}

void
log(const char *fmt,...)
{
  va_list         ap;
  char           *strlog;

  strlog = (char *) malloc(MAX_SIZE_LOG_RECORD);
  va_start(ap, fmt);
  vsprintf(strlog, fmt, ap);
  va_end(ap);
#ifndef NO_LOG_THREAD
  _beginthread(&logrecord, NULL, THREAD_STACK_SIZE, (void *) strlog);
#ifdef UNIX_VERSION
  free(strlog);
#endif				/* UNIX_VERSION */
#else
  logrecord((void *) strlog);
#endif
}

void
translate_hex(bufhex * hbuf, int flag_translate, struct shared_data * gl, int table)
{
  unsgchar       *findbuf;

  if (hbuf->size == 0)
    return;
  switch (hbuf->flhexw)
  {
  case 1:
    {
      hbuf->buf--;
      hbuf->size++;
      *hbuf->buf = hbuf->hexchar;
      hex_translate(hbuf->buf, flag_translate, table, gl);
      hbuf->flhexw = 0;
      hbuf->offset = 0;
      break;
    }
  case 2:
    {
      if (hbuf->size > 1)
      {
	hbuf->buf--;
	hbuf->size++;
	*hbuf->buf = '%';
	hbuf->flhexw = 0;
	hbuf->offset = 0;
      } else
      {
	hbuf->hexchar = *hbuf->buf;
	hbuf->size--;
	hbuf->flhexw = 3;
	hbuf->offset = 2;
	return;
      }
      break;
    }
  case 3:
    {
      hbuf->buf--;
      *hbuf->buf = hbuf->hexchar;
      hbuf->buf--;
      *hbuf->buf = '%';
      hbuf->size = hbuf->size + 2;
      hbuf->flhexw = 0;
      hbuf->offset = 0;
      break;
    }
  }
  findbuf = hbuf->buf;
  while ((findbuf = (unsgchar *) memchr(findbuf, (int) '%',
			       (hbuf->buf - findbuf) + hbuf->size)) != NULL)
  {
    if ((hbuf->buf + hbuf->size - findbuf) > 2)
      hex_translate(findbuf + 1, flag_translate, table, gl);
    else
    {
      if ((hbuf->buf + hbuf->size - 1) == findbuf)
      {
	hbuf->size--;
	hbuf->flhexw = 2;
	hbuf->offset = 1;
	break;
      } else
      {
	hbuf->hexchar = findbuf[1];
	hbuf->size--;
	hbuf->flhexw = 1;
	hbuf->offset = 1;
      }
    }
    findbuf++;
  }
  return;
}

#ifdef MIN_THREAD

void            _Optlink
Request(void *num_socket)
{
  unsgchar        rcvbuf[BUFFER_SIZE];
  unsgchar       *prcvbuf;
  unsgchar        sndbuf[BUFFER_SIZE];
  unsgchar       *psndbuf;
  int             rcount, scount;
  fd_set          fdsr;
  fd_set          fdss;
  fd_set          fdse;
  int             res;
  int             fltrans;
  int             flend, flendw;
  struct sockaddr_in proxy;
  int             insock, proxysock;
  int             table;
  int             flheadw;
  bufhex          hrbuf, hsbuf;
  int             flsend_in, flsend_proxy, flrecv_in, flrecv_proxy;
  int             statr0, statr1;
  int             stats0, stats1;

#ifdef UNIX_VERSION
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  unset_signals();
  signal(SIGUSR1, deattach);
  soclose(sock);
#endif
  statr0 = 0;
  statr1 = 0;
  stats0 = 0;
  stats1 = 0;
  gl->number_threads++;
  table = gl->translate_from_page;
  insock = (int) num_socket;
  log("Thread %d : New connection .", gettid());
  proxysock = socket(AF_INET, SOCK_STREAM, 0);
  if (proxysock < 0)
  {
    log("Thread %d : Error (%d) at create socket .", gettid(), ERRNO);
    goto exit;
  }
  proxy.sin_family = AF_INET;
  proxy.sin_port = htons(proxy_port);
  proxy.sin_addr.s_addr = proxy_address;
  if (connect(proxysock, (struct sockaddr *) & proxy, sizeof(proxy)) < 0)
  {
    log("Thread %d : Error (%d) at connect to proxy .", gettid(), ERRNO);
    goto exit;
  }
  flend = 0;
  flendw = 0;
  fltrans = 0;
  hrbuf.flhexw = 0;
  hrbuf.offset = 0;
  hsbuf.flhexw = 0;
  hsbuf.offset = 0;
  rcount = 0;
  scount = 0;
  flheadw = 1;
  flsend_in = 0;
  flsend_proxy = 0;
  flrecv_in = 1;
  flrecv_proxy = 1;
  FD_ZERO(&fdsr);
  FD_ZERO(&fdss);
  FD_ZERO(&fdse);
  do
  {
    if (flrecv_in)
      FD_SET(insock, &fdsr);
    if (flrecv_proxy)
      FD_SET(proxysock, &fdsr);
    if (flrecv_in || flsend_in)
      FD_SET(insock, &fdse);
    if (flrecv_proxy || flsend_proxy)
      FD_SET(proxysock, &fdse);
    if (flsend_in)
      FD_SET(insock, &fdss);
    if (flsend_proxy)
      FD_SET(proxysock, &fdss);
    res = select(((proxysock > insock) ? proxysock : insock) + 1, &fdsr, &fdss, &fdse, NULL);
    if (res > -1)
    {
      if (FD_ISSET(insock, &fdsr))
      {
	FD_CLR(insock, &fdsr);
	if (rcount < (BUFFER_SIZE - 2))
	{
	  res = recv(insock, rcvbuf + rcount + hrbuf.offset, BUFFER_SIZE - rcount - 2, 0);
	  if (res < 0)
	  {
	    if (ERRNO != S_EINTR)
	    {
	      log("Thread %d : Problem (%d) at receive from client", gettid(), ERRNO);
	      flend = 1;
	    } else
	      log("Thread %d : EINTR detected at receive from client .", gettid());
	  } else if (res == 0)
	  {
	    log("Thread %d : Client close connection .", gettid());
	    flendw = 1;
	    flrecv_in = 0;
	  } else
	  {
	    statr0 = statr0 + res;
	    hrbuf.buf = rcvbuf + rcount + hrbuf.offset;
	    hrbuf.size = res;
	    if (gl->flag_hex_translate)
	      translate_hex(&hrbuf, 2, gl, table);
	    if (rcount == 0)
	      prcvbuf = hrbuf.buf;
	    translate(hrbuf.buf, hrbuf.size, 2, table, gl);
	    rcount = rcount + hrbuf.size;
	    flsend_proxy = 1;
	  }
	}
      }
      if (FD_ISSET(proxysock, &fdsr))
      {
	FD_CLR(proxysock, &fdsr);
	if (scount < (BUFFER_SIZE - hsbuf.offset - 1))
	{
	  res = recv(proxysock, sndbuf + scount + hsbuf.offset, BUFFER_SIZE - scount - hsbuf.offset - 1, 0);
	  if (res < 0)
	  {
	    if (ERRNO != S_EINTR)
	    {
	      log("Thread %d : Problem (%d) at receive from proxy", gettid(), ERRNO);
	      flend = 1;
	    } else
	      log("Thread %d : EINTR detected at receive from proxy .", gettid());
	  } else if (res == 0)
	  {
	    log("Thread %d : Proxy close connection .", gettid());
	    flendw = 1;
	    flrecv_proxy = 0;
	  } else
	  {
	    statr1 = statr1 + res;
	    hsbuf.buf = sndbuf + scount + hsbuf.offset;
	    hsbuf.size = res;
	    if (gl->flag_all_translate || !flheadw)
	    {
	      if (gl->flag_all_translate || fltrans)
	      {
		if (gl->flag_hex_translate)
		  translate_hex(&hsbuf, 1, gl, table);
		translate(hsbuf.buf, hsbuf.size, 1, table, gl);
	      }
	      if (scount == 0)
		psndbuf = hsbuf.buf;
	      scount = scount + hsbuf.size;
	      flsend_in = 1;
	    } else
	    {
	      scount = scount + res;
	      if (flheadw && (scount >= MAX_MIME_HEADER_SIZE))
	      {
		hsbuf.size = scount;
		hsbuf.buf = sndbuf + hsbuf.offset;
		fltrans = find_header(&hsbuf, &table, gl);
		scount = hsbuf.size;
		psndbuf = hsbuf.buf;
		flsend_in = 1;
		flheadw = 0;
	      }
	    }
	  }
	}
      }
      if (FD_ISSET(proxysock, &fdss))
      {
	FD_CLR(proxysock, &fdss);
	if (sendflush(proxysock, prcvbuf, rcount, &stats1) != rcount)
	{
	  log("Thread %d : Problem (%d) at send to client", gettid(), ERRNO);
	  flend = 1;
	} else
	{
	  rcount = 0;
	  flsend_proxy = 0;
	}
      }
      if (FD_ISSET(insock, &fdss))
      {
	FD_CLR(insock, &fdss);
	if (sendflush(insock, psndbuf, scount, &stats0) != scount)
	{
	  log("Thread %d : Problem (%d) at send to proxy", gettid(), ERRNO);
	  flend = 1;
	} else
	{
	  scount = 0;
	  flsend_in = 0;
	}
      }
      if (FD_ISSET(insock, &fdse) || FD_ISSET(proxysock, &fdse))
      {
	if (ERRNO != S_EINTR)
	{
	  log("Thread %d : Error (%d) at socket", gettid(), ERRNO);
	  flend = 1;
	} else
	  log("Thread %d : EINTR detected at select exceptions .", gettid());
      }
    } else
    {
      if (ERRNO != S_EINTR)
      {
	log("Thread %d : Select return error (%d) .", gettid(), ERRNO);
	flend = 1;
      } else
	log("Thread %d : EINTR detected at select .", gettid());
    }
  } while (!flend && (!(flendw && (rcount == 0) && (scount == 0))));
  shutdown(proxysock, 2);
  soclose(proxysock);
exit:
  log("Thread %d : Connection closed (client: %d->%d proxy: %d->%d) .", gettid(),
      statr0, stats1, statr1, stats0);
#ifdef CLOSE_WAIT
  DosSleep(1000 * SEND_TIME_WAIT);
#endif
  shutdown(insock, 2);
  soclose(insock);
#ifdef UNIX_VERSION
  (void) deattach(0);
#else
  gl->number_threads--;
#endif
  _endthread();
}
#endif				/* MIN_THREAD */

#ifdef I_HATE_ifdef
#error Sorry .
#endif
